#include <libraries/mui.h>
#include <proto/muimaster.h>
#include <clib/exec_protos.h>
#include <exec/memory.h>

#ifndef MAKE_ID
#define MAKE_ID(a,b,c,d) ((ULONG) (a)<<24 | (ULONG) (b)<<16 | (ULONG) (c)<<8 | (ULONG) (d))
#endif

#ifdef __DCC
#define __inline
#endif

/*	ExTended KeyButton ( or Eric Totel KeyButton :-) )	*/
/*	to use with localization features 			*/

static APTR __inline ETKeyButton(char *text)
{
        return (KeyButton(&text[3], text[1]));
}

/* Global variables */
APTR App, WI_main, TX_text1, LV_float1, BT_group, BT_frames, BT_backfill;
APTR BT_notify, BT_listview, BT_cycle, BT_image, BT_string, BT_quit;
APTR WI_groups, LV_float2, GA_vert1, GA_vert2, GA_vert3, GA_horiz1;
APTR GA_horiz2, GA_horiz3, GA_array1, GA_array2, GA_array3, GA_array4;
APTR GA_array5, GA_array6, GA_array7, GA_array8, GA_array9, BT_25kg;
APTR BT_50kg, BT_75kg, BT_100kg, TX_label_1, TX_label_2, TX_label_3;
APTR TX_label_4, TX_label_5, WI_frames, LV_float3, TX_button, TX_imagebutton;
APTR TX_text, TX_string, TX_readlist, TX_inputlist, TX_prop, TX_group;
APTR WI_notify, LV_float4, GA_connect1, PR_label_0, PR_label_1, SL_label_0;
APTR SL_label_1, SL_label_2, GA_label_16, PR_label_2, PR_label_3, GA_label_17;
APTR WI_listviews, LV_float5, LV_label_5, LV_label_6, WI_string, LV_label_7;
APTR LV_label_8, STR_label_0, WI_images, LV_label_9, IM_label_0, IM_label_1;
APTR IM_label_2, IM_label_3, IM_label_4, IM_label_5, IM_label_6, IM_label_7;
APTR IM_label_8, IM_label_9, IM_label_35;
char *STR_TX_text1, *STR_LV_float1, *STR_LV_float2, *STR_TX_label_1;
char *STR_TX_label_2, *STR_TX_label_3, *STR_TX_label_4, *STR_TX_label_5;
char *STR_LV_float3, *STR_TX_button, *STR_TX_imagebutton, *STR_TX_text;
char *STR_TX_string, *STR_TX_readlist, *STR_TX_inputlist, *STR_TX_prop;
char *STR_TX_group, *STR_LV_float4, *STR_LV_float5, *STR_LV_label_7;
char *STR_LV_label_9;

BOOL CreateApp( void )
{
	BOOL Result = TRUE;

	STR_TX_text1 = "\033c\0338MUI - MagicUserInterface\nwritten 1993 by Stefan Stuntz";
	STR_LV_float1 = NULL;
	STR_LV_float2 = NULL;
	STR_TX_label_1 = "fixed";
	STR_TX_label_2 = "\033cfree";
	STR_TX_label_3 = "fixed";
	STR_TX_label_4 = "\033cfree";
	STR_TX_label_5 = "fixed";
	STR_LV_float3 = NULL;
	STR_TX_button = "\033cButton";
	STR_TX_imagebutton = "\033cImageButton";
	STR_TX_text = "\033cText";
	STR_TX_string = "\033cString";
	STR_TX_readlist = "\033cReadList";
	STR_TX_inputlist = "\033cInputList";
	STR_TX_prop = "\033cProp Gadget";
	STR_TX_group = "\033cGroup";
	STR_LV_float4 = NULL;
	STR_LV_float5 = NULL;
	STR_LV_label_7 = NULL;
	STR_LV_label_9 = NULL;

	App = ApplicationObject,
		MUIA_Application_Author, "Stefan Stuntz",
		MUIA_Application_Base, "MUIDEMO",
		MUIA_Application_Title, "MUIDemo",
		MUIA_Application_Version, "$VER: MUI-Demo 1.0 (xx.xx.xx)",
		MUIA_Application_Copyright, "Stefan Stuntz",
		MUIA_Application_Description, "Just a demo !!!",
		SubWindow, WI_main = WindowObject,
			MUIA_Window_Title, "MUI-Demo",
			MUIA_Window_ID, MAKE_ID( '0','W','I','N' ),
			WindowContents, GroupObject,
				Child, TX_text1 = TextObject,
					MUIA_Background, 133,
					MUIA_Text_Contents, STR_TX_text1,
					MUIA_Text_SetMax, 0,
					MUIA_Text_SetMin, 1,
					MUIA_Frame, 9,
				End,
				Child, LV_float1 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, FloattextObject,
						MUIA_Floattext_Text, STR_LV_float1,
						ReadListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, GroupObject,
					GroupFrameT( "Available Demos" ),
					MUIA_Group_Columns, 3,
					MUIA_Group_SameWidth, TRUE,
					Child, BT_group = KeyButton( "Groups",'g' ),
					Child, BT_frames = KeyButton( "Frames",'f' ),
					Child, BT_backfill = KeyButton( "Backfill",'b' ),
					Child, BT_notify = KeyButton( "Notify",'n' ),
					Child, BT_listview = KeyButton( "Listviews",'l' ),
					Child, BT_cycle = KeyButton( "Cycle",'c' ),
					Child, BT_image = KeyButton( "Images",'i' ),
					Child, BT_string = KeyButton( "Strings",'s' ),
					Child, BT_quit = KeyButton( "Quit",'q' ),
				End,
			End,
		End,
		SubWindow, WI_groups = WindowObject,
			MUIA_Window_Title, "Groups",
			MUIA_Window_ID, MAKE_ID( '1','W','I','N' ),
			WindowContents, GroupObject,
				Child, LV_float2 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, FloattextObject,
						MUIA_Floattext_Text, STR_LV_float2,
						ReadListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, GroupObject,
					GroupFrameT( "Group Types" ),
					MUIA_Group_Horiz, TRUE,
					Child, GroupObject,
						GroupFrameT( "Horizontal" ),
						MUIA_Group_Horiz, TRUE,
						Child, GA_vert1 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_Gauge_Horiz, FALSE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_vert2 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_Gauge_Horiz, FALSE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_vert3 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_Gauge_Horiz, FALSE,
							MUIA_Gauge_Max, 100,
						End,
					End,
					Child, GroupObject,
						GroupFrameT( "Vertical" ),
						Child, GA_horiz1 = GaugeObject,
							GaugeFrame,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_horiz2 = GaugeObject,
							GaugeFrame,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_horiz3 = GaugeObject,
							GaugeFrame,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
					End,
					Child, GroupObject,
						GroupFrameT( "Array" ),
						MUIA_Group_Columns, 3,
						Child, GA_array1 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array2 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array3 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array4 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array5 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array6 = GaugeObject,
							GaugeFrame,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array7 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array8 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, GA_array9 = GaugeObject,
							GaugeFrame,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
					End,
				End,
				Child, GroupObject,
					GroupFrameT( "Different Weights" ),
					MUIA_Group_Horiz, TRUE,
					Child, BT_25kg = TextObject,
						ButtonFrame,
						MUIA_Text_Contents, "25 kg",
						MUIA_Text_PreParse, "\033c",
						MUIA_InputMode, 1,
						MUIA_Background, 2,
						MUIA_Weight, 25,
					End,
					Child, BT_50kg = TextObject,
						ButtonFrame,
						MUIA_Text_Contents, "50 kg",
						MUIA_Text_PreParse, "\033c",
						MUIA_InputMode, 1,
						MUIA_Background, 2,
						MUIA_Weight, 50,
					End,
					Child, BT_75kg = SimpleButton( "75 kg" ),
					Child, BT_100kg = SimpleButton( "100 kg" ),
				End,
				Child, GroupObject,
					GroupFrameT( "Fixed & Variable Sizes" ),
					MUIA_Group_Horiz, TRUE,
					Child, TX_label_1 = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_label_1,
						MUIA_Text_SetMax, 1,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 5,
					End,
					Child, TX_label_2 = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_label_2,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 5,
					End,
					Child, TX_label_3 = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_label_3,
						MUIA_Text_SetMax, 1,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 5,
					End,
					Child, TX_label_4 = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_label_4,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 5,
					End,
					Child, TX_label_5 = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_label_5,
						MUIA_Text_SetMax, 1,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 5,
					End,
				End,
			End,
		End,
		SubWindow, WI_frames = WindowObject,
			MUIA_Window_Title, "Frames",
			MUIA_Window_ID, MAKE_ID( '2','W','I','N' ),
			WindowContents, GroupObject,
				Child, LV_float3 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, FloattextObject,
						MUIA_Floattext_Text, STR_LV_float3,
						ReadListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, GroupObject,
					MUIA_Group_Columns, 2,
					Child, TX_button = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_button,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 1,
					End,
					Child, TX_imagebutton = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_imagebutton,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 2,
					End,
					Child, TX_text = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_text,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 3,
					End,
					Child, TX_string = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_string,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 4,
					End,
					Child, TX_readlist = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_readlist,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 5,
					End,
					Child, TX_inputlist = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_inputlist,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 6,
					End,
					Child, TX_prop = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_prop,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 7,
					End,
					Child, TX_group = TextObject,
						MUIA_Background, 128,
						MUIA_Text_Contents, STR_TX_group,
						MUIA_Text_SetMax, 0,
						MUIA_Text_SetMin, 1,
						MUIA_Frame, 9,
					End,
				End,
			End,
		End,
		SubWindow, WI_notify = WindowObject,
			MUIA_Window_Title, "Notifying",
			MUIA_Window_ID, MAKE_ID( '3','W','I','N' ),
			WindowContents, GroupObject,
				Child, LV_float4 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, FloattextObject,
						MUIA_Floattext_Text, STR_LV_float4,
						ReadListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, GroupObject,
					GroupFrameT( "Connections" ),
					MUIA_Group_Horiz, TRUE,
					Child, GroupObject,
						MUIA_Group_Horiz, TRUE,
						Child, GA_connect1 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_Gauge_Horiz, FALSE,
							MUIA_Gauge_Max, 100,
						End,
						Child, PR_label_0 = PropObject,
							PropFrame,
							MUIA_Prop_Entries, 100,
							MUIA_Prop_First, 0,
							MUIA_Prop_Horiz, FALSE,
							MUIA_Prop_Visible, 10,
							MUIA_FixWidth, 8,
						End,
						Child, PR_label_1 = PropObject,
							PropFrame,
							MUIA_Prop_Entries, 100,
							MUIA_Prop_First, 0,
							MUIA_Prop_Horiz, FALSE,
							MUIA_Prop_Visible, 10,
							MUIA_FixWidth, 8,
						End,
					End,
					Child, GroupObject,
						Child, HVSpace,
						Child, SL_label_0 = SliderObject,
							MUIA_Slider_Min, 0,
							MUIA_Slider_Max, 100,
							MUIA_Slider_Quiet, TRUE,
							MUIA_Slider_Level, 0,
							MUIA_Slider_Reverse, FALSE,
						End,
						Child, GroupObject,
							MUIA_Group_Horiz, TRUE,
							Child, SL_label_1 = SliderObject,
								MUIA_Slider_Min, 0,
								MUIA_Slider_Max, 100,
								MUIA_Slider_Quiet, TRUE,
								MUIA_Slider_Level, 0,
								MUIA_Slider_Reverse, FALSE,
							End,
							Child, SL_label_2 = SliderObject,
								MUIA_Slider_Min, 0,
								MUIA_Slider_Max, 100,
								MUIA_Slider_Quiet, TRUE,
								MUIA_Slider_Level, 0,
								MUIA_Slider_Reverse, FALSE,
							End,
						End,
						Child, HVSpace,
						Child, GA_label_16 = GaugeObject,
							GaugeFrame,
							MUIA_FixHeight, 10,
							MUIA_Gauge_Horiz, TRUE,
							MUIA_Gauge_Max, 100,
						End,
						Child, ScaleObject,
							MUIA_Scale_Horiz, 1,
						End,
						Child, HVSpace,
					End,
					Child, GroupObject,
						MUIA_Group_Horiz, TRUE,
						Child, PR_label_2 = PropObject,
							PropFrame,
							MUIA_Prop_Entries, 100,
							MUIA_Prop_First, 0,
							MUIA_Prop_Horiz, FALSE,
							MUIA_Prop_Visible, 10,
							MUIA_FixWidth, 8,
						End,
						Child, PR_label_3 = PropObject,
							PropFrame,
							MUIA_Prop_Entries, 100,
							MUIA_Prop_First, 0,
							MUIA_Prop_Horiz, FALSE,
							MUIA_Prop_Visible, 10,
							MUIA_FixWidth, 8,
						End,
						Child, GA_label_17 = GaugeObject,
							GaugeFrame,
							MUIA_FixWidth, 15,
							MUIA_Gauge_Horiz, FALSE,
							MUIA_Gauge_Max, 100,
						End,
					End,
				End,
			End,
		End,
		SubWindow, WI_listviews = WindowObject,
			MUIA_Window_Title, "ListViews",
			MUIA_Window_ID, MAKE_ID( '4','W','I','N' ),
			WindowContents, GroupObject,
				Child, LV_float5 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, FloattextObject,
						MUIA_Floattext_Text, STR_LV_float5,
						ReadListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, GroupObject,
					GroupFrameT( "Dir & Volume List" ),
					MUIA_Group_Horiz, TRUE,
					Child, LV_label_5 = ListviewObject,
						MUIA_Listview_List, DirlistObject,
							InputListFrame,
							MUIA_Dirlist_Directory, "progdir:",
							MUIA_Dirlist_DrawersOnly, FALSE,
							MUIA_Dirlist_FilesOnly, FALSE,
							MUIA_Dirlist_FilterDrawers, FALSE,
							MUIA_Dirlist_MultiSelDirs, FALSE,
							MUIA_Dirlist_RejectIcons, FALSE,
							MUIA_Dirlist_SortDirs, MUIV_Dirlist_SortDirs_First,
							MUIA_Dirlist_SortHighLow, FALSE,
							MUIA_Dirlist_SortType, 0,
						End,
					End,
					Child, LV_label_6 = ListviewObject,
						MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
						MUIA_Listview_List, VolumelistObject,
							InputListFrame,
							MUIA_Listview_DoubleClick, TRUE,
						End,
					End,
				End,
			End,
		End,
		SubWindow, WI_string = WindowObject,
			MUIA_Window_Title, "String",
			MUIA_Window_ID, MAKE_ID( '5','W','I','N' ),
			WindowContents, GroupObject,
				Child, LV_label_7 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, FloattextObject,
						MUIA_Floattext_Text, STR_LV_label_7,
						ReadListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, LV_label_8 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, ListObject,
						InputListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, STR_label_0 = StringObject,
					StringFrame,
					MUIA_String_MaxLen, 80,
					MUIA_String_Format, 0,
				End,
			End,
		End,
		SubWindow, WI_images = WindowObject,
			MUIA_Window_Title, "Images",
			MUIA_Window_ID, MAKE_ID( '6','W','I','N' ),
			WindowContents, GroupObject,
				Child, LV_label_9 = ListviewObject,
					MUIA_Listview_MultiSelect, MUIV_Listview_MultiSelect_Default,
					MUIA_Listview_List, FloattextObject,
						MUIA_Floattext_Text, STR_LV_label_9,
						ReadListFrame,
						MUIA_Listview_DoubleClick, TRUE,
					End,
				End,
				Child, GroupObject,
					MUIA_Group_Horiz, TRUE,
					MUIA_Group_SameHeight, TRUE,
					Child, GroupObject,
						GroupFrameT( "Some Images" ),
						MUIA_Group_Columns, 2,
						Child, Label( "ArrowUp:" ),
						Child, IM_label_0 = ImageObject,
							MUIA_Image_Spec, 11,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "ArrowDown" ),
						Child, IM_label_1 = ImageObject,
							MUIA_Image_Spec, 12,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "ArrowLeft:" ),
						Child, IM_label_2 = ImageObject,
							MUIA_Image_Spec, 14,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "ArrowRight:" ),
						Child, IM_label_3 = ImageObject,
							MUIA_Image_Spec, 13,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "RadioButton" ),
						Child, IM_label_4 = ImageObject,
							MUIA_Image_Spec, 16,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "File:" ),
						Child, IM_label_5 = ImageObject,
							MUIA_Image_Spec, 19,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "HardDisk:" ),
						Child, IM_label_6 = ImageObject,
							MUIA_Image_Spec, 23,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "Disk" ),
						Child, IM_label_7 = ImageObject,
							MUIA_Image_Spec, 24,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "Chip:" ),
						Child, IM_label_8 = ImageObject,
							MUIA_Image_Spec, 25,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
						Child, Label( "Drawer:" ),
						Child, IM_label_9 = ImageObject,
							MUIA_Image_Spec, 22,
							MUIA_Image_FreeVert, TRUE,
							MUIA_Image_FreeHoriz, TRUE,
							MUIA_FixHeight, 10,
							MUIA_FixWidth, 8,
							MUIA_InputMode, MUIV_InputMode_RelVerify,
						End,
					End,
					Child, GroupObject,
						GroupFrameT( "Scale Engine" ),
						Child, HVSpace,
						Child, GroupObject,
							MUIA_Group_Horiz, TRUE,
							Child, ImageObject,
								MUIA_Image_Spec, 16,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 10,
								MUIA_FixWidth, 8,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 16,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 14,
								MUIA_FixWidth, 12,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 16,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 18,
								MUIA_FixWidth, 22,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 16,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 20,
								MUIA_FixWidth, 26,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 16,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 22,
								MUIA_FixWidth, 34,
							End,
						End,
						Child, HVSpace,
						Child, GroupObject,
							MUIA_Group_Horiz, TRUE,
							Child, ImageObject,
								MUIA_Image_Spec, 19,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 10,
								MUIA_FixWidth, 8,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 19,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 12,
								MUIA_FixWidth, 12,
							End,
							Child, IM_label_35 = ImageObject,
								MUIA_Image_Spec, 19,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 14,
								MUIA_FixWidth, 16,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 19,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 16,
								MUIA_FixWidth, 20,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 19,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 18,
								MUIA_FixWidth, 24,
							End,
							Child, ImageObject,
								MUIA_Image_Spec, 19,
								MUIA_Image_FreeVert, TRUE,
								MUIA_Image_FreeHoriz, TRUE,
								MUIA_FixHeight, 20,
								MUIA_FixWidth, 28,
							End,
						End,
						Child, HVSpace,
					End,
				End,
			End,
		End,
	End;

	if (!(App))
	{
		Result = FALSE;
	}
	return( Result );
}

void DisposeApp( void )
{
	MUI_DisposeObject(App);
	
}